JSB.require('utils')
/** @return {networkController} */
const getNetworkController = ()=>self

var networkController = JSB.defineClass('networkController : UIViewController <UIWebViewDelegate>', {
  viewDidLoad: function() {
    let self = getNetworkController()
    try {
    self.init()
    self.creatWebview()
    self.creatButtons()
    } catch (error) {
      showHUD(error)
    }
    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    // Application.sharedInstance().showHUD("test", self.view.window, 2);

    // self.appInstance.showHUD("123",self.view.window,2)
    // UIView.beginAnimationsContext(undefined,undefined)
    // UIView.setAnimationDuration(10)
    // UIView.commitAnimations
    // UIView.animateWithDurationAnimations(10,1)
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    // self.appInstance.showHUD("123",self.view.window,2)

    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
  viewWillLayoutSubviews: function() {
    let self = getNetworkController()
    if (self.miniMode) {
      // self.webview.hidden = true
      return
    }

    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.closeButton.frame = {x: xRight-18,y: yTop,width: 18,height: 18};
    self.maxButton.frame   = {x: xRight-43,y: yTop,width: 18,height: 18};
    self.screenButton.frame = {x: xRight - 37,y: yBottom - 35,width: 30,height: 30};
    self.moveButton.frame = {  x: xRight*0.5-75,  y: yTop,  width: 150,  height: 12,};
    self.searchButton.frame = {  x: xRight - 72,  y: yBottom - 35,  width: 30,  height: 30,}
    self.multiButton.frame = {  x: xRight - 107,  y: yBottom - 35,  width: 30,  height: 30,}
    self.focusButton.frame = {  x: xRight - 142,  y: yBottom - 35,  width: 30,  height: 30,}
    self.snipasteButton.frame = {  x: xRight - 177,  y: yBottom - 35,  width: 30,  height: 30,}
    self.goBackButton.frame = {  x: xLeft+6,  y: yBottom - 35,  width: 30,  height: 30,};
    self.goForwardButton.frame = {  x: xLeft+41,  y: yBottom - 35,  width: 30,  height: 30,};
    self.webview.frame = {x:xLeft+1,y:yTop+6,width:viewFrame.width-2,height:viewFrame.height-6}
    if (self.settingView && !self.settingView.hidden) {
      self.settingViewLayout()
    }
  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
  },
  webViewDidFinishLoad: function(webView) {
    let currentURL = webView.request.URL().absoluteString()
    // self.appInstance.showHUD(currentURL, self.view.window, 2);
    // self.goBackButton.hidden = !webView.canGoBack
    // self.goForwardButton.hidden = !webView.canGoForward
    if (!self.htmlMode) {
      return
    }
    webView.evaluateJavaScript(`
      document.getElementsByClassName("body")[0].offsetHeight
    `,ret=>{
      if (ret !== NSNull.new()) {
      // Application.sharedInstance().showHUD(ret, self.view.window, 2);
      let viewFrame = self.view.frame
      viewFrame.height = parseFloat(ret)+40
      self.view.frame = viewFrame
      self.currentFrame = viewFrame
      }
    })
  },
  webViewDidFailLoadWithError: function(webView, error) {
  },
  webViewShouldStartLoadWithRequestNavigationType: function(webView,request,type){
    let self = getNetworkController()
    let requestURL = request.URL().absoluteString()
    if (/^marginnote3app/.test(requestURL)) {
      showHUD("Return to source...");
      let noteid = requestURL.split("marginnote3app://note/")[1]
      // Application.sharedInstance().openURL(NSURL.URLWithString(requestURL));
        let docMapSplitMode = studyController().docMapSplitMode
        switch (docMapSplitMode) {
          case 0:
            studyController().focusNoteInMindMapById(noteid)
            break;
          case 1:
            studyController().focusNoteInMindMapById(noteid)
            studyController().focusNoteInDocumentById(noteid)
            break;
          case 2:
            studyController().focusNoteInDocumentById(noteid)
            break;
          default:
            break;
        }

      return false
    }
    if (/^snipaste:\/\//.test(requestURL)) {
      let noteid = requestURL.split("snipaste://note/")[1]
      postNotification('snipasteNote', {noteid:noteid})
      return false
    } 
    // showHUD(requestURL)
    if (/^notification:\/\/stabilizationIterationsDone/.test(requestURL)) {
      if (self.nextStep && self.nextStep.length) {
      // showHUD("Add new",1)
        // copy(self.nextStep[1])
        self.add(self.nextStep[0],self.nextStep[1])
        self.nextStep=[]
      }
      return false
    }
    // if (/^notification:\/\/afterDrawing/.test(requestURL)) {
    //   // showHUD("Add new",1)
    //   // if (self.nextStep && self.nextStep.length) {
    //   //   self.add(self.nextStep[0],self.nextStep[1])
    //   //   self.nextStep=[]
    //   // }
    //   self.fit()
    //   return false
    // }
    return true;
  },
  changeScreen: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'🌗 Left',object:self,selector:'leftButtonTapped:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'left13ButtonTapped:',param:'left',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'rightButtonTapped:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'right13ButtonTapped:',param:'right',checked:self.customMode==="right13"},
      {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender},
      {title:'⚙️ Setting',object:self,selector:'openSettingView:',param:sender},
    ];
    self.view.popoverController = getPopoverAndPresent(sender, commandTable,250)
  },
  changeImageSize: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'70',object:self,selector:'setImageSize:',param:70},
      {title:'60',object:self,selector:'setImageSize:',param:60},
      {title:'50',object:self,selector:'setImageSize:',param:50},
      {title:'40',object:self,selector:'setImageSize:',param:40},
      {title:'30',object:self,selector:'setImageSize:',param:30},
      {title:'20',object:self,selector:'setImageSize:',param:20},
    ];
    self.view.popoverController = getPopoverAndPresent(sender, commandTable,100)
  },
  setImageSize: function (size) {
    let self = getNetworkController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.config.imageSize = size
    self.imageSizeButton.setTitleForState("Image size: "+size)
    setLocalDataByKey(self.config, "MNNetwork")
  },
  changeSearchDepth: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'*️⃣ Unlimited',object:self,selector:'setSearchDepth:',param:-1,checked:self.config.searchDepth===-1},
      {title:'2️⃣ Depth: 2',object:self,selector:'setSearchDepth:',param:2,checked:self.config.searchDepth=== 2},
      {title:'3️⃣ Depth: 3',object:self,selector:'setSearchDepth:',param:3,checked:self.config.searchDepth=== 3},
      {title:'4️⃣ Depth: 4',object:self,selector:'setSearchDepth:',param:4,checked:self.config.searchDepth=== 4},
      {title:'5️⃣ Depth: 5',object:self,selector:'setSearchDepth:',param:5,checked:self.config.searchDepth=== 5},
      {title:'6️⃣ Depth: 6',object:self,selector:'setSearchDepth:',param:6,checked:self.config.searchDepth=== 6},
      {title:'7️⃣ Depth: 7',object:self,selector:'setSearchDepth:',param:7,checked:self.config.searchDepth=== 7},
      {title:'8️⃣ Depth: 8',object:self,selector:'setSearchDepth:',param:8,checked:self.config.searchDepth=== 8},
      {title:'9️⃣ Depth: 9',object:self,selector:'setSearchDepth:',param:9,checked:self.config.searchDepth=== 9},
    ];
    self.view.popoverController = getPopoverAndPresent(sender, commandTable,200)
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
  },
  setSearchDepth:function (depth) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.config.searchDepth = depth
    let docMapSplitMode = self.appInstance.studyController(self.view.window).docMapSplitMode
      // Application.sharedInstance().showHUD(self.appInstance.studyController(self.view.window).view.subviews, self.view.window, 5)
    // UIPasteboard.generalPasteboard().string = self.appInstance.studyController(self.view.window).view.subviews
    let focusNote
    if (docMapSplitMode===2) {
      focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
    }else{
      focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
    }
    if (focusNote) {
      self.setMultiOrderNetwork2Step(focusNote)
      // self.setNetwork(focusNote)
    }
    setLocalDataByKey(self.config, "MNNetwork")
    self.updateButton.setTitleForState("Search depth: "+self.config.searchDepth)
    // self.setMultiOrderNetwork()
  },
  setColorFilter:function (button) {
    let index = button.index
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.config.colorFilter[index] = !self.config.colorFilter[index]
    self["ColorButton"+index].setTitleForState(self.config.colorFilter[index]?"✓":"✖️",0)
    setLocalDataByKey(self.config, "MNNetwork")


  },
  toggleBacklink:function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.config.backLink = !self.config.backLink
    setLocalDataByKey(self.config, "MNNetwork")
    self.linkButton.setTitleForState("Back link: "+(self.config.backLink?"✅":"🚫"),0)
    
    // Application.sharedInstance().showHUD(self.color, self.view.window, 5)

    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
  },
  searchButtonTapped: function() {
    let docMapSplitMode = self.appInstance.studyController(self.view.window).docMapSplitMode
      // Application.sharedInstance().showHUD(self.appInstance.studyController(self.view.window).view.subviews, self.view.window, 5)
    // UIPasteboard.generalPasteboard().string = self.appInstance.studyController(self.view.window).view.subviews
    let focusNote
    if (docMapSplitMode===2) {
      focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
    }else{
      focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
    }
    if (focusNote) {
      // self.setMultiOrderNetwork(focusNote)
      self.setNetwork(focusNote)
    }else{
      self.appInstance.showHUD("No note selected", this.view.window, 2)
    }
      },
  multiButtonTapped: function() {
    let self = getNetworkController()
      // Application.sharedInstance().showHUD(123, self.view.window, 5)
    let docMapSplitMode = self.appInstance.studyController(self.view.window).docMapSplitMode
    // UIPasteboard.generalPasteboard().string = self.appInstance.studyController(self.view.window).view.subviews
    let focusNote
    if (docMapSplitMode===2) {
      focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
    }else{
      focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
    }
    if (focusNote) {
      // self.setMultiOrderNetwork(focusNote)
      self.setMultiOrderNetwork2Step(focusNote)
      // self.setNetwork(focusNote)
    }else{
      self.appInstance.showHUD("No note selected", this.view.window, 2)
    }
      },
  goBackButtonTapped: function() {
    self.webview.goBack();
  },
  goForwardButtonTapped: function() {
    self.webview.goForward();
  },
  focusButtonTapped: function() {
    let self = getNetworkController()
    self.runJavaScript(`network.focus("${self.noteid}",{scale:${self.config.focusScale},animation:true})`)
  },
  snipasteButtonTapped: async function() {
    let self = getNetworkController()
    let noteid = (await self.runJavaScript("network.getSelectedNodes()")).split('"')[1]
    if (noteid) {
      postNotification('snipasteNote', {noteid:noteid})
    }
  },
  closeButtonTapped: function() {
    self.runJavaScript("network.destroy()")
    self.hide(self.addonBar.frame)
    },
  leftButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    self.lastFrame = self.view.frame
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.dynamic = false;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "left13"
    self.dynamic = false;
    self.lastFrame = self.view.frame

    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "right"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.custom = true;
    self.customMode = "right13"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.webview.hidden = false
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let locationToMN = gesture.locationInView(self.appInstance.studyController(self.view.window).view)
    if (!self.miniMode && (Date.now() - self.moveDate) > 100) {
      let translation = gesture.translationInView(self.appInstance.studyController(self.view.window).view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
      }
      // if ((newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) || !self.locationToBrowser) {

      // }
    }
    self.moveDate = Date.now()
    let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}

    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    if (!self.miniMode) {
      if (locationToMN.x<40) {
        self.miniMode = true 
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:0,
          y:locationToMN.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.focusButton.hidden = true
        self.multiButton.hidden = true
        self.moveButton.frame = {
          x: -10,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
      if (locationToMN.x>studyFrame.width-40) {
        x=studyFrame.width-frame.width*0.5-40
        self.miniMode = true     
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:studyFrame.width-40,
          y:frame.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.searchButton.hidden = true
        self.focusButton.hidden = true
        self.multiButton.hidden = true
        self.moveButton.frame = {
          x: 0,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
    }else{
      if (locationToMN.x<50) {
        self.view.frame = {
          x:0,
          y:locationToMN.y-20,
          width:40,
          height:40
        }
        return
      }else if (locationToMN.x>studyFrame.width-50) {
        self.view.frame = {
          x:studyFrame.width-40,
          y:locationToMN.y-20,
          width:40,
          height:40
        }
        return
      }else if (locationToMN.x>50) {
        self.view.frame = {
          x:x,
          y:y,
          width:self.lastFrame.width,
          height:self.lastFrame.height
        }
        self.currentFrame = self.view.frame
        self.view.hidden = false
        self.webview.hidden = false
        self.focusButton.hidden = false
        self.multiButton.hidden = false
        self.moveButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5-75,
          y: viewFrame.y + 5,
          width: 150,
          height: 10,
        };
        self.webview.hidden = false
        self.closeButton.hidden = false
        self.maxButton.hidden = false
        self.screenButton.hidden = false
        self.searchButton.hidden = false
        self.miniMode = false
        return
      }
    }
    
    if (self.custom) {
      self.customMode = "None"
      self.view.frame = {x:x,y:y,width:self.lastFrame.width,height:self.lastFrame.height}
      self.currentFrame  = self.view.frame

    }else{
      self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
      self.currentFrame  = self.view.frame

    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
  openSettingView:function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    try {
      
    self.createSettingView()
    self.settingViewLayout()
    } catch (error) {
      showHUD(error)
    }
  },
  closeConfig:function (params) {
    self.configView.hidden = true
  },
  togglePreview:function (params) {
    self.config.preview = !self.config.preview
    self.previewButton.setTitleForState("Preview on hover: "+(self.config.preview?"✅":"🚫"),0)
    setLocalDataByKey(self.config, "MNNetwork")
  },
  changeClickAction:function (button) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let index = button.click
    var commandTable = [
      {title:'Show card',object:self,selector:'setClickAction:',param:[index,1]},
      {title:'Snipaste',object:self,selector:'setClickAction:',param:[index,2]},
      {title:'Focus',object:self,selector:'setClickAction:',param:[index,3]},
      {title:'Copy URL',object:self,selector:'setClickAction:',param:[index,4]},
      {title:'Nothing',object:self,selector:'setClickAction:',param:[index,0]}
    ];
    self.view.popoverController = getPopoverAndPresent(button, commandTable,200)
  },
  setClickAction:function (param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    switch (param[0]) {
      case 1:
        self.config.singleClick = param[1]
        self.singleClickButton.setTitleForState("Single Click on node: "+self.getActionText(param[1]),0)
        break;
      case 2:
        self.config.doubleClick = param[1]
        self.doubleClickButton.setTitleForState("Double Click on node: "+self.getActionText(param[1]),0)
        break;
      default:
        break;
    }
    self.runActionScript()
    setLocalDataByKey(self.config, "MNNetwork")
  },
  changeFocusScale:function (button) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'1',object:self,selector:'setFocusScale:',param:1},
      {title:'2',object:self,selector:'setFocusScale:',param:2},
      {title:'3',object:self,selector:'setFocusScale:',param:3},
    ];
    self.view.popoverController = getPopoverAndPresent(button, commandTable,200)
  },
  setFocusScale:function (scale) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.config.focusScale = scale
    self.focusScaleButton.setTitleForState("Focus Scale: "+scale)
    self.runActionScript()
    setLocalDataByKey(self.config, "MNNetwork")
  }
});
/**
 * @this {networkController}
 */
networkController.prototype.init = function () {
  let config = NSUserDefaults.standardUserDefaults().objectForKey("MNNetwork")
  if (!config) {
    config = {
      searchDepth:2,
      colorFilter:[true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true],
      backLink:false
    }
  }
  if (!config.imageSize) {
    config.imageSize = 50
  }
  if (config.preview === undefined) {
    config.preview = true
  }
  if (config.singleClick === undefined) {
    config.singleClick = 0
  }
  if (config.doubleClick === undefined) {
    config.doubleClick = 1
  }
  if (config.focusScale === undefined) {
    config.focusScale = 1
  }
  this.custom = false;
  this.customMode = "None"
  this.dynamic = true;
  this.miniMode = false;
  this.isLoading = false;
  this.lastFrame = this.view.frame;
  this.currentFrame = this.view.frame
  this.config = config
  // this.searchDepth = config.searchDepth
  // this.backLink = config.backLink
  // this.color = config.colorFilter
  // this.imageSize = config.imageSize
  this.moveDate = Date.now()
  this.view.layer.shadowOffset = {width: 0, height: 0};
  this.view.layer.shadowRadius = 15;
  this.view.layer.shadowOpacity = 0.5;
  this.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
  this.view.layer.opacity = 1.0
  this.appInstance = Application.sharedInstance();
  this.homeImage = getImage(this.mainPath + `/home.png`)
  this.gobackImage = getImage(this.mainPath + `/goback.png`)
  this.goforwardImage = getImage(this.mainPath + `/goforward.png`)
  this.screenImage = getImage(this.mainPath + `/screen.png`)
  this.networkImage = getImage(this.mainPath + `/network.png`)
  this.multiImage = getImage(this.mainPath + `/multi.png`)
  this.focusImage = getImage(this.mainPath + `/focus.png`)
  this.snipasteImage = getImage(this.mainPath + `/snipaste.png`)
  this.stopImage = getImage(this.mainPath + `/stop.png`)
  this.view.layer.shadowOffset = {width: 0, height: 0};
  this.view.layer.shadowRadius = 15;
  this.view.layer.shadowOpacity = 0.5;
  // this.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
  this.view.layer.opacity = 1.0
}
/**
 * @this {networkController}
 */
networkController.prototype.creatWebview = function () {
  this.webview = new UIWebView(this.view.bounds);
  // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0(Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, likeGecko) Version/13.1.1 Safari/605.1.15',"UserAgent")
  this.webview.backgroundColor = UIColor.whiteColor();
  this.webview.scalesPageToFit = true;
  this.webview.autoresizingMask = (1 << 1 | 1 << 4);
  this.webview.delegate = this;
  // this.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari605.1.15","User-Agent")
  this.webview.scrollView.delegate = this;
  this.webview.layer.cornerRadius = 15;
  this.webview.layer.masksToBounds = true;
  this.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari605.1.15'
      // UIPasteboard.generalPasteboard().string = html
  this.webview.loadFileURLAllowingReadAccessToURL(
    NSURL.fileURLWithPath(this.mainPath + '/network.html'),
    NSURL.fileURLWithPath(this.mainPath + '/')
  );
  // this.webview.loadHTMLStringBaseURL(html)
  this.highlightColor = UIColor.blendedColor(
    UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
    Application.sharedInstance().defaultTextColor,
    0.8
  );
  // >>> DeepL langauge button >>>
  // this.webview.lanButton = UIButton.buttonWithType(0);
  // <<< DeepL langauge button <<<
  this.webview.hidden = true;
  this.webview.lastOffset = 0;
  this.view.addSubview(this.webview);
}
/**
 * @this {networkController}
 */
networkController.prototype.creatButtons = function (params) {
  this.closeButton = UIButton.buttonWithType(0);
  this.setButtonLayout(this.closeButton,"closeButtonTapped:")
  this.closeButton.setTitleForState('✖️', 0);
  this.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
  // <<< close button <<<
  // >>> max button >>>
  this.maxButton = UIButton.buttonWithType(0);
  this.setButtonLayout(this.maxButton,"maxButtonTapped:")
  this.maxButton.setTitleForState('➕', 0);
  this.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
  // <<< max button <<<
  // >>> screen button >>>
  this.screenButton = UIButton.buttonWithType(0);
  this.setButtonLayout(this.screenButton,"changeScreen:")
  this.screenButton.setImageForState(this.screenImage,0)
  // <<< screen button <<<
  // >>> search button >>>
  this.searchButton = UIButton.buttonWithType(0);
  this.setButtonLayout(this.searchButton,"searchButtonTapped:")
  this.searchButton.setImageForState(this.networkImage,0)
  // this.searchButton.setTitleForState('🔍', 0);
  // <<< search button <<<
  // >>> search button >>>
  this.multiButton = UIButton.buttonWithType(0);
  this.setButtonLayout(this.multiButton,"multiButtonTapped:")
  this.multiButton.setImageForState(this.multiImage,0)
  // this.searchButton.setTitleForState('🔍', 0);
  // <<< search button <<<
  // >>> move button >>>
  this.moveButton = UIButton.buttonWithType(0);
  this.setButtonLayout(this.moveButton)
  // <<< move button <<<
  // >>> goForward button >>>
  this.goForwardButton = UIButton.buttonWithType(0);
  // this.setButtonLayout(this.goForwardButton,"goForwardButtonTapped:")
  // this.goForwardButton.setImageForState(this.goforwardImage,0)
  // <<< goForward button <<<
    // >>> goBack button >>>
  this.goBackButton = UIButton.buttonWithType(0);
  // this.setButtonLayout(this.goBackButton,"goBackButtonTapped:")
  // this.goBackButton.setImageForState(this.gobackImage,0)
  // <<< goBack button <<<
    // >>> focus button >>>
  this.focusButton = UIButton.buttonWithType(0);
  this.setButtonLayout(this.focusButton,"focusButtonTapped:")
  this.focusButton.setImageForState(this.focusImage,0)
  // <<< focus button <<<
  // >>> snipaste button >>>
  this.snipasteButton = UIButton.buttonWithType(0);
  this.setButtonLayout(this.snipasteButton,"snipasteButtonTapped:")
  this.snipasteButton.setImageForState(this.snipasteImage,0)
  // <<< snipaste button <<<
}
networkController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
/**
 * @param {MbBookNote} focusNote
 * @this {networkController}
 */
networkController.prototype.setNetwork = function (focusNote) {
try {
  

  this.htmlMode = true
  this.noteid = focusNote.noteId
  this.nodes = [];
  this.sideNodes = []
  this.linkCount = {}
  this.getLinkNodes(focusNote,1,1)
  // this.titleLink = true
  // UIPasteboard.generalPasteboard().string = linkedNotes.join(",")
  // let titleLinkNote = this.getTitleLinks(focusNote)

  let backLinedNotes = this.getBackLinks(focusNote)
  let AllNodes =  Array.from(new Set(
                  this.nodes
                  .map(linkedNote=>getNoteById(linkedNote))
                  .concat(backLinedNotes,focusNote)
                  ))
  this.linkCount[this.noteid] = AllNodes.length
  // showHUD("length:"+focusNote.linkedNotes.length)
  let titleColor = ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
  let noteColorHexes = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
  let theme = this.appInstance.currentTheme
  let themeHtml = `      
    body{
      -webkit-text-fill-color: rgb(0, 0, 0);
    }`
  if (theme === "Gray") {
    noteColorHexes = ["#d2d294","#a8d1a1","#94accf","#d89dac","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#aa8ec4"]
    themeHtml = `      
    body{
      background-color: #414141;
      -webkit-text-fill-color: rgb(255, 255, 255);
    }`
  }else if (theme === "Dark") {
    noteColorHexes = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
    themeHtml = `      
    body{
      background-color: #121212;
      -webkit-text-fill-color: rgb(233, 232, 232);
    }`
  }

  if (AllNodes.length > 30) {
    showHUD(AllNodes.length+" nodes in rendering...")
  }
    let allNodesHtml = AllNodes.map((nodeNote)=>{
    // let nodeNote = Database.sharedInstance().getNoteById(node.noteid)
    let backgroundColor = noteColorHexes[nodeNote.colorIndex]
    let fontColor = titleColor[nodeNote.colorIndex]
    return this.getNodeInfo(nodeNote,backgroundColor,fontColor);
  }).join(",")
    // UIPasteboard.generalPasteboard().string = allNodesHtml
  let title = focusNote.noteTitle
  let titleKeywords
  if (title) {
    if (/;/.test(title)) {
      titleKeywords = title.split(";").map(key=>key.trim())
    }else{
      titleKeywords = title.split("；").map(key=>key.trim())
    }
  }
  let backEdges = this.getBackEdges(focusNote, backLinedNotes)
  let edgesHtml = this.nodes.map((node)=>{
    let note = getNoteById(node)
    let preEdge = `{ from: "${focusNote.noteId}", to: "${node}", arrows: "to"}`
    let backLink = note.linkedNotes.some(linkedNote=>linkedNote.noteid === focusNote.noteId)
    if (backLink) {
      return preEdge+`,{ from: "${node}", to: "${focusNote.noteId}", arrows: "to"}`
    }
    let allText = (note.excerptText?note.excerptText:"")+(note.notesText?note.notesText:"")
    if (titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)) {
      return preEdge+`,{ from: "${node}", to: "${focusNote.noteId}", arrows: "to", dashes: true}`
    }
    return `{ from: "${focusNote.noteId}", to: "${node}", arrows: "to"}`
  })
.concat(backEdges).join(",")
// showHUD(edgesHtml)
// copy(edgesHtml)
  // showHUD("123")
  this.runJavaScript(this.getScript(allNodesHtml,edgesHtml))
  // this.view.hidden = false
  // this.webview.hidden = false
} catch (error) {
  showHUD(error)
}
}
/**
 * @this {networkController}
 */
networkController.prototype.setMultiOrderNetwork = function (focusNote) {
try {
  this.nodes = [focusNote.noteId];
  this.edges = [];
  this.noteid = focusNote.noteId
  if (self.config.searchDepth === -1) {
    this.getLinkNodes(focusNote,1)
  }else{
    this.getLinkNodes(focusNote,1,self.config.searchDepth)
  }
  let backLinedNotes = this.getBackLinks(focusNote)
  let AllNodes =  Array.from(new Set(
                  this.nodes
                  .map(linkedNote=>getNoteById(linkedNote))
                  .concat(backLinedNotes)
                  ))
  let titleColor      =  ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
  let noteColorHexes  =  ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
  let theme = this.appInstance.currentTheme
  let themeHtml = `      
    body{
      -webkit-text-fill-color: rgb(0, 0, 0);
    }`
  if (theme === "Gray") {
    titleColor      = ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
    noteColorHexes  = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
    themeHtml = `      
    body{
      background-color: #414141;
      -webkit-text-fill-color: rgb(255, 255, 255);
    }`
  }else if (theme === "Dark") {
    noteColorHexses = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
    themeHtml = `      
    body{
      background-color: #121212;
      -webkit-text-fill-color: rgb(233, 232, 232);
    }`
  }
  if (AllNodes.length > 30 && AllNodes.length <= 300) {
    showHUD(AllNodes.length+" nodes in rendering...")
  }
  if (AllNodes.length > 300) {
    showHUD("Find "+AllNodes.length+" nodes, too large to render!")
    return    
  }
  // let backLinkHtml = backLinedNotes.map(node=>{
  //   let backgroundColor = noteColorHexes[node.colorIndex]
  //   let fontColor = titleColor[node.colorIndex]
  //   return this.getNodeInfo(node,backgroundColor,fontColor);
  // })
  let backEdges = this.getBackEdges(focusNote, backLinedNotes)
  // let backEdges = backLinedNotes.map(note=>`{ from: "${note.noteId}", to: "${focusNote.noteId}", arrows: "to"}`).join(",")
  // this.appInstance.showHUD("length:"+backLinedNotes.length,this.view.window,2)
  let nodesHtml = AllNodes.map((note)=>{
    try {
      let backgroundColor = noteColorHexes[note.colorIndex]
      let fontColor = titleColor[note.colorIndex]
      return this.getNodeInfo(note,backgroundColor,fontColor);
    } catch (error) {
      showHUD(error)
      return `{ 
        id: "${note.noteId}",
        label: "error", 
        title: "${error}", 
        shape:"box",
        margin:10,
        borderWidth:${node.noteId === focusNote.noteId?3:1},
        mass:${Math.sqrt(5)},
        widthConstraint:{maximum:150}
      }`
    }
  }).join(",")
  // UIPasteboard.generalPasteboard().string = nodesHtml

  // showHUD(titleKeywords)
  this.nodes.forEach(node=>{
    let nodeNote = getNoteById(node)
    let nodeEdges = ""
    if (nodeNote.linkedNotes.length !== 0) {
      nodeEdges = nodeNote.linkedNotes.map(note=>`{ from: "${node}", to: "${note.noteid}", arrows: "to"}`).join(",")
    }
    if (node == focusNote.noteId) {
      if (nodeEdges !== "") {
        this.edges.push(nodeEdges)
      }
      return
    }
    if (nodeEdges !== "") {
      this.edges.push(nodeEdges)
    }
  })
  let edgesHtml
  // let title = focusNote.noteTitle
  // let titleKeywords = this.getKeywords(title)
  // if (titleKeywords && titleKeywords.length) {
  //   let titleEdges = []
  //   this.nodes.forEach(node=>{
  //     let nodeNote = getNoteById(node)
  //     let nodeEdges = ""
  //     let allText = (nodeNote.excerptText?nodeNote.excerptText:"")+(nodeNote.notesText?nodeNote.notesText:"")
  //     if (titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)) {
  //       nodeEdges =  `{ from: "${node}", to: "${focusNote.noteId}", arrows: "to", dashes: true}`
  //       titleEdges.push(nodeEdges)
  //     }
  //   })
  //   edgesHtml = this.edges.concat(backEdges,titleEdges).join(",")
  // }else{
    edgesHtml = this.edges.concat(backEdges).join(",")
  // }
  // copy(edgesHtml)
          // UIPasteboard.generalPasteboard().string = comment.html
  this.runJavaScript(this.getScript(nodesHtml,edgesHtml))
  // this.webview.evaluateJavaScript(this.getScript(nodesHtml,edgesHtml),ret=>{})
  // this.view.hidden = false
  // this.webview.hidden = false
} catch (error) {
  showHUD(error)
}
}
/**
 * @this {networkController}
 */
networkController.prototype.setMultiOrderNetwork2Step = function (focusNote) {
try {
  let dateNow = Date.now()
  
  this.nodes = [focusNote.noteId];
  this.sideNodes = []
  this.edges = [];
  this.sideEdges = []
  this.linkCount = {}
  this.noteid = focusNote.noteId
  if (self.config.searchDepth === -1) {
    this.getLinkNodes2Step(focusNote,1)
  }else{
    this.getLinkNodes2Step(focusNote,1,self.config.searchDepth)
  }
  let backLinedNotes = this.getBackLinks(focusNote)
  this.linkCount[this.noteid] = backLinedNotes.length
  let AllNodes =  Array.from(new Set(
                  this.nodes
                  .map(linkedNote=>getNoteById(linkedNote))
                  ))
                  // .concat(backLinedNotes)
  let titleColor      =  ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
  let noteColorHexes  =  ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
  let theme = this.appInstance.currentTheme
  let themeHtml = `      
    body{
      -webkit-text-fill-color: rgb(0, 0, 0);
    }`
  if (theme === "Gray") {
    titleColor      = ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
    noteColorHexes  = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
    themeHtml = `      
    body{
      background-color: #414141;
      -webkit-text-fill-color: rgb(255, 255, 255);
    }`
  }else if (theme === "Dark") {
    noteColorHexses = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
    themeHtml = `      
    body{
      background-color: #121212;
      -webkit-text-fill-color: rgb(233, 232, 232);
    }`
  }
  // if (AllNodes.length > 30 && AllNodes.length <= 300) {
  // }
  let nodeLength = AllNodes.length+this.sideNodes.length+backLinedNotes.length
  if (nodeLength > 1000) {
    showHUD("Find "+nodeLength+" nodes, too large to render!")
    return    
  }
    showHUD(nodeLength+" nodes in rendering...")
  // let backLinkHtml = backLinedNotes.map(node=>{
  //   let backgroundColor = noteColorHexes[node.colorIndex]
  //   let fontColor = titleColor[node.colorIndex]
  //   return this.getNodeInfo(node,backgroundColor,fontColor);
  // })
  // let backEdges = backLinedNotes.map(note=>`{ from: "${note.noteId}", to: "${focusNote.noteId}", arrows: "to"}`).join(",")
  // this.appInstance.showHUD("length:"+backLinedNotes.length,this.view.window,2)
  this.nodes.forEach(node=>{
    let nodeNote = getNoteById(node)
    let nodeEdges = ""
    if (nodeNote.linkedNotes.length !== 0) {
      nodeEdges = nodeNote.linkedNotes.map(note=>{
        if (this.linkCount[node]) {
          this.linkCount[node] = this.linkCount[node]+1
        }else{
          this.linkCount[node] = 1
        }
        if (this.linkCount[note.noteid]) {
          this.linkCount[note.noteid] = this.linkCount[note.noteid]+1
        }else{
          this.linkCount[note.noteid] = 1
        }
        return `{ from: "${node}", to: "${note.noteid}", arrows: "to"}`
      }).join(",")
    }
    if (node == focusNote.noteId) {
      if (nodeEdges !== "") {
        this.edges.push(nodeEdges)
      }
      return
    }
    if (nodeEdges !== "") {
      this.edges.push(nodeEdges)
    }
  })
  this.sideNodes.forEach(node=>{
    let nodeNote = getNoteById(node)
    let nodeEdges = ""
    if (nodeNote.linkedNotes.length !== 0) {
      nodeEdges = nodeNote.linkedNotes.map(note=>{
        if (this.linkCount[node]) {
          this.linkCount[node] = this.linkCount[node]+1
        }else{
          this.linkCount[node] = 1
        }
        if (this.linkCount[note.noteid]) {
          this.linkCount[note.noteid] = this.linkCount[note.noteid]+1
        }else{
          this.linkCount[note.noteid] = 1
        }
        return `{ from: "${node}", to: "${note.noteid}", arrows: "to"}`
      }).join(",")
    }
    if (node == focusNote.noteId) {
      if (nodeEdges !== "") {
        this.sideEdges.push(nodeEdges)
      }
      return
    }
    if (nodeEdges !== "") {
      this.sideEdges.push(nodeEdges)
    }
  })
  let nodesHtml = AllNodes.map((note)=>{
    try {
      let backgroundColor = noteColorHexes[note.colorIndex]
      let fontColor = titleColor[note.colorIndex]
      return this.getNodeInfo(note,backgroundColor,fontColor);
    } catch (error) {
      showHUD(error)
      return `{ 
        id: "${note.noteId}",
        label: "error", 
        title: "${error}", 
        shape:"box",
        margin:10,
        borderWidth:${node.noteId === focusNote.noteId?3:1},
        mass:${Math.sqrt(5)},
        widthConstraint:{maximum:150}
      }`
    }
  }).join(",")
  // UIPasteboard.generalPasteboard().string = nodesHtml

  // showHUD(titleKeywords)

  let edgesHtml
  // let title = focusNote.noteTitle
  // let titleKeywords = this.getKeywords(title)
  // if (titleKeywords && titleKeywords.length) {
  //   let titleEdges = []
  //   this.nodes.forEach(node=>{
  //     let nodeNote = getNoteById(node)
  //     let nodeEdges = ""
  //     let allText = (nodeNote.excerptText?nodeNote.excerptText:"")+(nodeNote.notesText?nodeNote.notesText:"")
  //     if (titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)) {
  //       nodeEdges =  `{ from: "${node}", to: "${focusNote.noteId}", arrows: "to", dashes: true}`
  //       titleEdges.push(nodeEdges)
  //     }
  //   })
  //   edgesHtml = this.edges.concat(backEdges,titleEdges).join(",")
  // }else{
    // edgesHtml = this.edges.concat(backEdges).join(",")
    edgesHtml = this.edges.join(",")

  // }
  // copy(edgesHtml)
          // UIPasteboard.generalPasteboard().string = comment.html
  this.runJavaScript(this.getScript(nodesHtml,edgesHtml))
  // showHUD("delay:"+(Date.now()-dateNow))
  let backEdges = this.getBackEdges(focusNote, backLinedNotes)
  let backNodesHtml = backLinedNotes.map((note)=>{
    try {
      let backgroundColor = noteColorHexes[note.colorIndex]
      let fontColor = titleColor[note.colorIndex]
      return this.getNodeInfo(note,backgroundColor,fontColor);
    } catch (error) {
      showHUD(error)
      return `{ 
        id: "${note.noteId}",
        label: "error", 
        title: "${error}", 
        shape:"box",
        margin:10,
        borderWidth:${node.noteId === focusNote.noteId?3:1},
        mass:${Math.sqrt(5)},
        widthConstraint:{maximum:150}
      }`
    }
  })
  let sideNodesHtml = this.sideNodes.map((noteId)=>{
    let note = getNoteById(noteId)
    try {
      let backgroundColor = noteColorHexes[note.colorIndex]
      let fontColor = titleColor[note.colorIndex]
      return this.getNodeInfo(note,backgroundColor,fontColor);
    } catch (error) {
      showHUD(error)
      return `{ 
        id: "${noteId}",
        label: "error", 
        title: "${error}", 
        shape:"box",
        margin:10,
        borderWidth:1,
        mass:${Math.sqrt(5)},
        widthConstraint:{maximum:150}
      }`
    }
  }).concat(backNodesHtml).join(",")
  let sideEdgeHtml = this.sideEdges.concat(backEdges).join(",")
  this.nextStep = [sideNodesHtml, sideEdgeHtml]
  // delay(5).then(()=>{
  //   this.add(backNodesHtml, backEdges)
  // })
  // this.webview.evaluateJavaScript(this.getScript(nodesHtml,edgesHtml),ret=>{})
  // this.view.hidden = false
  // this.webview.hidden = false
} catch (error) {
  showHUD(error)
}
}
/**
 * @this {networkController}
 */
networkController.prototype.setMultiOrderNetworkByStep = function (focusNote) {
try {
  // let dateNow = Date.now()
  
  this.nodes = [focusNote.noteId];
  this.sideNodes = []
  this.edges = [];
  this.sideEdges = []
  this.noteid = focusNote.noteId
  // if (self.config.searchDepth === -1) {
  //   this.getLinkNodesByStep(focusNote,1)
  // }else{
  //   this.getLinkNodesByStep(focusNote,1,self.config.searchDepth)
  // }
  // let backLinedNotes = this.getBackLinks(focusNote)
  let AllNodes =  Array.from(new Set(
                  this.nodes
                  .map(linkedNote=>getNoteById(linkedNote))
                  ))
                  // .concat(backLinedNotes)
  let titleColor      =  ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
  let noteColorHexes  =  ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
  let theme = this.appInstance.currentTheme
  let themeHtml = `      
    body{
      -webkit-text-fill-color: rgb(0, 0, 0);
    }`
  if (theme === "Gray") {
    titleColor      = ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
    noteColorHexes  = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
    themeHtml = `      
    body{
      background-color: #414141;
      -webkit-text-fill-color: rgb(255, 255, 255);
    }`
  }else if (theme === "Dark") {
    noteColorHexses = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
    themeHtml = `      
    body{
      background-color: #121212;
      -webkit-text-fill-color: rgb(233, 232, 232);
    }`
  }
  // if (AllNodes.length > 30 && AllNodes.length <= 300) {
  // }
  // let nodeLength = AllNodes.length
  // if (nodeLength > 1000) {
  //   showHUD("Find "+nodeLength+" nodes, too large to render!")
  //   return    
  // }
    // showHUD(nodeLength+" nodes in rendering...")
  // let backLinkHtml = backLinedNotes.map(node=>{
  //   let backgroundColor = noteColorHexes[node.colorIndex]
  //   let fontColor = titleColor[node.colorIndex]
  //   return this.getNodeInfo(node,backgroundColor,fontColor);
  // })
  // let backEdges = backLinedNotes.map(note=>`{ from: "${note.noteId}", to: "${focusNote.noteId}", arrows: "to"}`).join(",")
  // this.appInstance.showHUD("length:"+backLinedNotes.length,this.view.window,2)
  let nodesHtml = AllNodes.map((note)=>{
    try {
      let backgroundColor = noteColorHexes[note.colorIndex]
      let fontColor = titleColor[note.colorIndex]
      return this.getNodeInfo(note,backgroundColor,fontColor);
    } catch (error) {
      showHUD(error)
      return `{ 
        id: "${note.noteId}",
        label: "error", 
        title: "${error}", 
        shape:"box",
        margin:10,
        borderWidth:${node.noteId === focusNote.noteId?3:1},
        mass:${Math.sqrt(5)},
        widthConstraint:{maximum:150}
      }`
    }
  }).join(",")
  // UIPasteboard.generalPasteboard().string = nodesHtml

  // showHUD(titleKeywords)
  this.nodes.forEach(node=>{
    let nodeNote = getNoteById(node)
    let nodeEdges = ""
    if (nodeNote.linkedNotes.length !== 0) {
      nodeEdges = nodeNote.linkedNotes.map(note=>`{ from: "${node}", to: "${note.noteid}", arrows: "to"}`).join(",")
    }
    if (node == focusNote.noteId) {
      if (nodeEdges !== "") {
        this.edges.push(nodeEdges)
      }
      return
    }
    if (nodeEdges !== "") {
      this.edges.push(nodeEdges)
    }
  })
  let edgesHtml
  // let title = focusNote.noteTitle
  // let titleKeywords = this.getKeywords(title)
  // if (titleKeywords && titleKeywords.length) {
  //   let titleEdges = []
  //   this.nodes.forEach(node=>{
  //     let nodeNote = getNoteById(node)
  //     let nodeEdges = ""
  //     let allText = (nodeNote.excerptText?nodeNote.excerptText:"")+(nodeNote.notesText?nodeNote.notesText:"")
  //     if (titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)) {
  //       nodeEdges =  `{ from: "${node}", to: "${focusNote.noteId}", arrows: "to", dashes: true}`
  //       titleEdges.push(nodeEdges)
  //     }
  //   })
  //   edgesHtml = this.edges.concat(backEdges,titleEdges).join(",")
  // }else{
    // edgesHtml = this.edges.concat(backEdges).join(",")
    edgesHtml = this.edges.join(",")

  // }
  // copy(edgesHtml)
          // UIPasteboard.generalPasteboard().string = comment.html
  this.runJavaScript(this.getScript(nodesHtml,edgesHtml))
    this.getLinkNodesByStep(focusNote,1)

  // showHUD("delay:"+(Date.now()-dateNow))
  // let backEdges = this.getBackEdges(focusNote, backLinedNotes)
  // let backNodesHtml = backLinedNotes.map((note)=>{
  //   try {
  //     let backgroundColor = noteColorHexes[note.colorIndex]
  //     let fontColor = titleColor[note.colorIndex]
  //     return this.getNodeInfo(note,backgroundColor,fontColor);
  //   } catch (error) {
  //     showHUD(error)
  //     return `{ 
  //       id: "${note.noteId}",
  //       label: "error", 
  //       title: "${error}", 
  //       shape:"box",
  //       margin:10,
  //       borderWidth:${node.noteId === focusNote.noteId?3:1},
  //       mass:${Math.sqrt(5)},
  //       widthConstraint:{maximum:150}
  //     }`
  //   }
  // })
  // let sideNodesHtml = this.sideNodes.map((noteId)=>{
  //   let note = getNoteById(noteId)
  //   try {
  //     let backgroundColor = noteColorHexes[note.colorIndex]
  //     let fontColor = titleColor[note.colorIndex]
  //     return this.getNodeInfo(note,backgroundColor,fontColor);
  //   } catch (error) {
  //     showHUD(error)
  //     return `{ 
  //       id: "${noteId}",
  //       label: "error", 
  //       title: "${error}", 
  //       shape:"box",
  //       margin:10,
  //       borderWidth:1,
  //       mass:${Math.sqrt(5)},
  //       widthConstraint:{maximum:150}
  //     }`
  //   }
  // }).concat(backNodesHtml).join(",")
  // this.sideNodes.forEach(node=>{
  //   let nodeNote = getNoteById(node)
  //   let nodeEdges = ""
  //   if (nodeNote.linkedNotes.length !== 0) {
  //     nodeEdges = nodeNote.linkedNotes.map(note=>`{ from: "${node}", to: "${note.noteid}", arrows: "to"}`).join(",")
  //   }
  //   if (node == focusNote.noteId) {
  //     if (nodeEdges !== "") {
  //       this.sideEdges.push(nodeEdges)
  //     }
  //     return
  //   }
  //   if (nodeEdges !== "") {
  //     this.sideEdges.push(nodeEdges)
  //   }
  // })
  // let sideEdgeHtml = this.sideEdges.concat(backEdges).join(",")
  // this.nextStep = [sideNodesHtml, sideEdgeHtml]
  // delay(5).then(()=>{
  //   this.add(backNodesHtml, backEdges)
  // })
  // this.webview.evaluateJavaScript(this.getScript(nodesHtml,edgesHtml),ret=>{})
  // this.view.hidden = false
  // this.webview.hidden = false
} catch (error) {
  showHUD(error)
}
}
/**
 * 
 * @param {MbBookNote} note 
 * @param {number} depth 
 * @param {number} maxdepth 
 * @this {networkController}
 * @returns 
 */
networkController.prototype.getLinkNodes = function (note,depth = 1,maxdepth=100) {
  let filterNotes = note.linkedNotes.filter(linkedNote=>{
    if (this.nodes.includes(linkedNote.noteid)) {
      return false
    }
    let nodeNote =  getNoteById(linkedNote.noteid)
    if (nodeNote) {
  // showHUD("colorIndex:"+nodeNote.colorIndex)
      return nodeNote.colorIndex == -1 || this.config.colorFilter[nodeNote.colorIndex]
    }else{
      return false
    }
  
  })
  // showHUD("length:"+filterNotes.length)

  if (filterNotes.length === 0) {
    return
  }
  this.nodes = this.nodes.concat(filterNotes.map(note=>note.noteid))
  if (depth>=maxdepth) {
    return;
  }
  // this.appInstance.showHUD("nodes: "+this.nodes.length,this.view.window,2)
  filterNotes.forEach(note=>{
    let nodeNote = getNoteById(note.noteid)
    this.getLinkNodes(nodeNote,depth+1,maxdepth)
  })
}

/**
 * 
 * @param {MbBookNote} note 
 * @param {number} depth 
 * @param {number} maxdepth 
 * @this {networkController}
 * @returns 
 */
networkController.prototype.getLinkNodes2Step = function (note,depth = 1,maxdepth=100) {
  let filterNotes = note.linkedNotes.filter(linkedNote=>{
    if (this.nodes.includes(linkedNote.noteid) || this.sideNodes.includes(linkedNote.noteid)) {
      return false
    }
    let nodeNote =  getNoteById(linkedNote.noteid)
    if (nodeNote) {
  // showHUD("colorIndex:"+nodeNote.colorIndex)
      return nodeNote.colorIndex == -1 || this.config.colorFilter[nodeNote.colorIndex]
    }else{
      return false
    }
  
  })
  if (filterNotes.length === 0) {
    return
  }
  if (depth <= 4) {
    this.nodes = this.nodes.concat(filterNotes.map(note=>note.noteid))
  }else{
    this.sideNodes = this.sideNodes.concat(filterNotes.map(note=>note.noteid))
  }
  if (depth>=maxdepth) {
    return;
  }
  // this.appInstance.showHUD("nodes: "+this.nodes.length,this.view.window,2)
  filterNotes.forEach(note=>{
    let nodeNote = getNoteById(note.noteid)
    this.getLinkNodes2Step(nodeNote,depth+1,maxdepth)
  })
}
/**
 * 
 * @param {MbBookNote} note 
 * @param {number} depth 
 * @param {number} maxdepth 
 * @this {networkController}
 * @returns 
 */
networkController.prototype.getLinkNodesByStep = function (note,depth = 1,maxdepth=100) {
  let filterNotes = note.linkedNotes.filter(linkedNote=>{
    if (this.nodes.includes(linkedNote.noteid)) {
      return false
    }
    let nodeNote =  getNoteById(linkedNote.noteid)
    if (nodeNote) {
  // showHUD("colorIndex:"+nodeNote.colorIndex)
      return nodeNote.colorIndex == -1 || this.config.colorFilter[nodeNote.colorIndex]
    }else{
      return false
    }
  
  })
  if (filterNotes.length === 0) {
    return
  }
  this.nodes = this.nodes.concat(filterNotes.map(note=>note.noteid))
  if (depth>=maxdepth) {
    return;
  }
  // this.appInstance.showHUD("nodes: "+this.nodes.length,this.view.window,2)
  filterNotes.forEach(note=>{
    let nodeNote = getNoteById(note.noteid)
    this.getLinkNodesByStep(nodeNote,depth+1,maxdepth)
  })
}
networkController.prototype.getKeywords = function (title) {
  let keywords
  if (title && title !== "") {
    if (/;/.test(title)) {
      keywords =  title.split(";").map(key=>key.trim())
    }else{
      keywords =  title.split("；").map(key=>key.trim())
    }
    return keywords
  }else{
    return undefined
  }

}
/**
 * 
 * @param {MbBookNote} nodeNote 
 * @param {*} backgroundColor 
 * @param {*} titleColor 
 * @returns 
 * @this {networkController}
 */
networkController.prototype.getNodeInfo = function (nodeNote,backgroundColor,titleColor) {
  // let color = noteColorHexes[nodeNote.colorIndex]
  let size = 14
  let maxWidth = 150
  if (this.linkCount && this.linkCount[nodeNote.noteId]) {
    size = 14+this.linkCount[nodeNote.noteId]*0.3
    maxWidth = 150+this.linkCount[nodeNote.noteId]*5
  }
  if (size > 30) {
    size = 30
  }
  if (maxWidth > 300) {
    maxWidth = 300
  }
  // if (nodeNote.linkedNotes.length > 14) {
  //   // size = nodeNote.linkedNotes.length
  //   maxWidth = 300
  // }
  let test = {
    id:nodeNote.noteId,
    color:backgroundColor,
    font:{color:titleColor,size:size},
    borderWidth:1,
    widthConstraint:{maximum:maxWidth}
  }
  if (!this.config.preview) {
    let label = this.getNodeLabel(nodeNote,test)
    return JSON.stringify(label)
  }
  let title = nodeNote.noteTitle?nodeNote.noteTitle:"..."
  let excerpt
  if (nodeNote.excerptPic && !nodeNote.textFirst) {
    let imageData = Database.sharedInstance().getMediaByHash(nodeNote.excerptPic.paint)
    excerpt = `<img width="100%" src="data:image/jpeg;base64,${imageData.base64Encoding()}"/>`
  }else{
    excerpt = nodeNote.excerptText?nodeNote.excerptText:""
  }

  let comments = nodeNote.comments.map(comment=>{
    switch (comment.type) {
      case "TextNote":
        if (/^marginnote3app/.test(comment.text)){
          return""
        }
        return `<div class="comment">${comment.text}</div>`
      case "PaintNote":
        //有时候comment有一个drawing属性，有时候是strokes属性
        // if (comment.drawing) {
        //   showHUD(comment.drawing)
        //   let data = Database.sharedInstance().getMediaByHash(comment.drawing)
        //   copy(data.base64Encoding())
        //   // let image = UIImage.imageWithData(data)
        //   studyController().focusNoteInMindMapById(nodeNote.noteId)
        //   // UIPasteboard.generalPasteboard().setDataForPasteboardType(data,"public.png")
        // }
        // if (comment.strokes) {
        //   showHUD(comment.strokes)
        //   copy(comment.strokes)
        //   studyController().focusNoteInMindMapById(nodeNote.noteId)
        //   let data = Database.sharedInstance().getMediaByHash(comment.strokes)
        //   UIPasteboard.generalPasteboard().setDataForPasteboardType(data,"public.png")
        //   // copy(data.base64Encoding())
        // }
        return this.getImageByHash(comment.paint)
      case "HtmlNote":
        return comment.html
      case "LinkNote":
        if (!comment.q_hpic || (comment.q_htext && nodeNote.textFirst)) {
          return `<div class="comment">${comment.q_htext}</div>`
        }else{
          return this.getImageByHash(comment.q_hpic.paint)
        }
      default:
        return "";
    }
  }).join("\n").trim()
  test.title = `<div class="linkedNode" style="border: 3px solid ${backgroundColor}"><div class="head" style="background-color:${backgroundColor}"><div class="title" style="color:${titleColor}">${title}</div></div><p class="excerpt">${excerpt}</p>${comments}<div class="tail"></div></div>`
  let label = this.getNodeLabel(nodeNote,test)
  // showHUD("return")

  return JSON.stringify(label)
  // return `{ 
  //   "id": "${nodeNote.noteId}",
  //   ${label}
  //   title:preTitle(\`<div class="linkedNode" style="border: 3px solid ${backgroundColor}"><div class="head" style="background-color:${backgroundColor}"><div class="title" style="color:${titleColor}">${title}</div></div><p class="excerpt">${excerpt}</p>${comments}<div class="tail"></div></div>\`), 
  //   color:"${backgroundColor}",
  //   font:{color:"${titleColor}"},
  //   borderWidth:1,
  //   size:50,
  //   widthConstraint:{maximum:150}
  // }`
}
/**
 * 
 * @param {string} nodesHtml 
 * @param {string} edgesHtml 
 * @returns {string}
 * @this {networkController}
 */
networkController.prototype.getScript = function (nodesHtml,edgesHtml) {
  let script = `
    if (network) {
      network.off('click')
      network.off('stabilizationIterationsDone')
      network.destroy()
      // network.off('afterDrawing')
    }
    tem0 = [${nodesHtml}].map(node=>{
      if (node.title) {
        node.title = preTitle(node.title)
      }
      return node
    })
    nodes = new vis.DataSet(tem0);
    edges = new vis.DataSet([${edgesHtml}]);
    var data = { nodes: nodes, edges: edges };
    var network = new vis.Network(container, data, options);
    network.on('click',function(properties){
      if (properties.nodes.length) {
        if (Date.now()-dateNow < 500) {
          ${this.getActionJS(this.config.doubleClick)}
        }else{
          ${this.getActionJS(this.config.singleClick)}
        }
        dateNow = Date.now()
      }else{
        if (Date.now()-dateClickBlank < 500) {
          network.fit({animation:true})
        }
        dateClickBlank = Date.now()
      }
    })
    network.on('stabilizationIterationsDone',function(properties){
      window.location.assign("notification://stabilizationIterationsDone");
    })
    // network.on('afterDrawing',function(properties){
    //   setInterval(() => {
    //     window.location.assign("notification://afterDrawing");
        
    //   }, 2000);
    // })
    `
    // copy(script)
  return script
}

/**
 * 
 * @param {string} nodesHtml 
 * @param {string} edgesHtml 
 * @this {networkController}
 */
networkController.prototype.add = async function (nodesHtml,edgesHtml) {
  let script = `
    tem0 = [${nodesHtml}].map(node=>{
      if (node.title) {
        node.title = preTitle(node.title)
      }
      return node
    })
    nodes.update(tem0)
    edges.add([${edgesHtml}])
    network.fit({animation:true})
    `
  await delay(0.2)
  this.runJavaScript(script, 0)
}
/**
 * @this {networkController}
 */
networkController.prototype.fit = function () {
  this.runJavaScript("network.fit({animation:true})", 0)
}
/**
 * 
 * @this {networkController}
 */
networkController.prototype.runActionScript = function () {
  this.runJavaScript(`
    network.off('click')
    network.on('click',function(properties){
      if (properties.nodes.length) {
        if (Date.now()-dateNow < 500) {
          ${this.getActionJS(this.config.doubleClick)}
        }else{
          ${this.getActionJS(this.config.singleClick)}
        }
        dateNow = Date.now()
      }else{
        if (Date.now()-dateClickBlank < 500) {
          network.fit({animation:true})
        }
        dateClickBlank = Date.now()
      }
    })
    `)
}
/**
 * 
 * @param {MbBookNote} focusNote 
 * @returns {MbBookNote[]}
 * @this {networkController}
 */
networkController.prototype.getBackLinks = function (focusNote) {
  if (!this.config.backLink) {
    // showHUD("backlink disabled")
    return [];
  }

  let title = focusNote.noteTitle
  let titleKeywords
  if (title) {
    if (/;/.test(title)) {
      titleKeywords = title.split(";").map(key=>key.trim())
    }else{
      titleKeywords = title.split("；").map(key=>key.trim())
    }
  }
  let backLinedNotes = Database.sharedInstance().getNotebookById(this.notebookid).notes.filter((node)=>{
      if (!this.config.colorFilter[node.colorIndex] || this.nodes.includes(node.noteId) || node.noteId === focusNote.noteId) {
        return false
      }
      let backLink = node.linkedNotes.some(linkedNote=>linkedNote.noteid === focusNote.noteId)
      if (backLink) { return true }
      if (!title || title === "") { return false }
      let allText = (node.excerptText?node.excerptText:"")+(node.notesText?node.notesText:"")
      return titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)
    })
  return backLinedNotes
}

networkController.prototype.getBackEdges = function (focusNote,backLinedNotes) {
  let title = focusNote.noteTitle
  let titleKeywords
  if (title) {
    if (/;/.test(title)) {
      titleKeywords = title.split(";").map(key=>key.trim())
    }else{
      titleKeywords = title.split("；").map(key=>key.trim())
    }
  }
  let backEdges = backLinedNotes.map((node)=>{
    let backLink = node.linkedNotes.some(linkedNote=>linkedNote.noteid === focusNote.noteId)
    if (backLink || !title || title === "") { return `{ from: "${node.noteId}", to: "${focusNote.noteId}", arrows: "to"}` }
    let allText = (node.excerptText?node.excerptText:"")+(node.notesText?node.notesText:"")
    if (titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)) {
      return `{ from: "${node.noteId}", to: "${focusNote.noteId}", arrows: "to", dashes: true}`
    }else{
      showHUD("test")
      return `{ from: "${node.noteId}", to: "${focusNote.noteId}", arrows: "to"}`
    }
  })
  return backEdges
}

networkController.prototype.getTitleLinks = function (focusNote) {
  if (!this.titleLink) {
    return [];
  }
  if (!focusNote.noteTitle) {
    return
  }
  let title = focusNote.noteTitle
  let titleKeywords
  if (/;/.test(title)) {
    titleKeywords = title.split(";").map(key=>key.trim())
  }else{
    titleKeywords = title.split("；").map(key=>key.trim())
  }
  let titleLinkNotes = Database.shareInstance().getNotebookById(this.notebookid).notes.filter((node)=>{
    if (node.noteId === focusNote.noteId) {
      return false
    }
    let allText = (node.excerptText?node.excerptText:"")+(node.notesText?node.notesText:"")
      return titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)
    })
  return titleLinkNotes
}

/** 
 * @this networkController 
 * @param {MbBookNote} note
 */
networkController.prototype.getNodeLabel = function (note,node) {
  let label
  // if (!note) {
  //   showHUD("no note",10)
  //   label = "undefined"
  //   node.label = label
  //   node.shape = "box"
  //   node.mass = Math.sqrt(label?label.length:9)
  //   return node
  // }
  if (note.noteTitle && note.noteTitle !== "") {
    label = note.noteTitle.replaceAll(";",";\n")
    node.label = label
    node.shape = "box"
    node.mass = this.calcNodeMass(note.noteId, label)
    return node
  }
  if (note.excerptPic && !note.textFirst) {
    let imageData = Database.sharedInstance().getMediaByHash(note.excerptPic.paint)
    if (!imageData) {
      label = "image"
      node.label = label
      node.shape = "box"
      node.mass = this.calcNodeMass(note.noteId, label)
      return node
    }
    let imageSize = UIImage.imageWithData(imageData).size
    let ratio = imageSize.width/imageSize.height
    // showHUD("ratio:"+ratio)

    label = `data:image/jpeg;base64,${imageData.base64Encoding()}`
    node.image = label
    node.shape = "image"
    node.mass = this.config.imageSize*0.1+3
    if (ratio > 10) {
      node.size = this.config.imageSize*5/ratio
    }else{
      node.size = this.config.imageSize
    }
    if (this.linkCount && this.linkCount[note.noteId]) {
      node.mass = node.mass+this.linkCount[note.noteId]
    }
    return node
  }
  if (note.excerptText && note.excerptText!=="") {
    label = note.excerptText
    if (label.length > 100) {
      label = (label.slice(0,100)+"...").replaceAll(`\n`,`\\n`)
    }
    node.label = label
    node.shape = "box"
    node.mass = this.calcNodeMass(note.noteId, label)
    return node
    // return `label: "${label}",shape:"box",mass:${Math.sqrt(label?label.length:9)},`
  }

  // showHUD(firstComment.type)
  let firstComment = note.comments.find(comment=>{
    switch (comment.type) {
      case "TextNote":
        if (/^marginnote3app/.test(comment.text)){
          return false
        }
        return true
      default:
        return true
    }
  })
  // showHUD("comment length:"+note.comments.length,10)
  // showHUD("comment length:"+note.comments.length,10)

  switch (firstComment.type) {
    case "TextNote":
      label = firstComment.text
      node.label = label
      node.shape = "box"
      node.mass = this.calcNodeMass(note.noteId, label)
      return node
      // return `label: "${label}",shape:"box",mass:${Math.sqrt(label?label.length:9)},`
    case "HtmlNote":
      label = firstComment.text
      node.label = label
      node.shape = "box"
      node.mass = this.calcNodeMass(note.noteId, label)
      return node
      // return `label: "${label}",shape:"box",mass:${Math.sqrt(label?label.length:9)},`
    case "PaintNote":
      if (firstComment.paint) {
        let commentImage = Database.sharedInstance().getMediaByHash(firstComment.paint)
        label = `data:image/jpeg;base64,${commentImage.base64Encoding()}`
        node.image = label
        node.shape = "image"
        node.size = this.config.imageSize
        node.mass = this.config.imageSize*0.1+3
        if (this.linkCount && this.linkCount[note.noteId]) {
          node.mass = node.mass+this.linkCount[note.noteId]
        }
        return node
      }else{
        label = "Hand writing"
        node.label = label
        node.shape = "box"
        node.mass = this.calcNodeMass(note.noteId, label)
        return node
        // return `label: "${label}",shape:"box",mass:${Math.sqrt(label?label.length:9)},`
      }
    case "LinkNote":
      if (!firstComment.q_hpic || (firstComment.q_htext && note.textFirst)) {
        label = firstComment.q_htext
        node.label = label
        node.shape = "box"
        node.mass = this.calcNodeMass(note.noteId, label)
        return node
        // return `label: "${label}",shape:"box",mass:${Math.sqrt(label?label.length:9)},`
      }else{
        let commentImage = Database.sharedInstance().getMediaByHash(firstComment.q_hpic.paint)
        label = `data:image/jpeg;base64,${commentImage.base64Encoding()}`
        node.image = label
        node.mass = this.config.imageSize*0.1+3
        node.size = this.config.imageSize
        node.shape = "image"
        if (this.linkCount && this.linkCount[note.noteId]) {
          node.mass = node.mass+this.linkCount[note.noteId]
        }
        return node
        // return `image: "${label}",shape:"image",mass:5,`
      }
    default:
      return ""
  }
}

networkController.prototype.calcNodeMass = function (noteId,label) {
  let length = Math.sqrt(label?label.length*0.5:9)
  if (this.linkCount && this.linkCount[noteId]) {
    length = length+Math.sqrt(this.linkCount[noteId]*0.5)
  }
  return length
}
/** @this networkController */
networkController.prototype.createSettingView = function (){
  this.creatView("configView","view","#9bb2d6",0.8)
  this.createButton("closeConfigButton","closeConfig:","configView")
  this.closeConfigButton.setImageForState(this.stopImage,0)
  this.closeConfigButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)

  this.createButton("updateButton","changeSearchDepth:","configView")
  this.updateButton.layer.opacity = 1.0
  this.updateButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.updateButton.setTitleForState("Search depth: "+this.config.searchDepth,0)
  
  this.createButton("linkButton","toggleBacklink:","configView")
  this.linkButton.layer.opacity = 1.0
  this.linkButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.linkButton.setTitleForState("Back link: "+(this.config.backLink?"✅":"🚫"),0)

  this.createButton("imageSizeButton","changeImageSize:","configView")
  this.imageSizeButton.layer.opacity = 1.0
  this.imageSizeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.imageSizeButton.setTitleForState("Image size: "+this.config.imageSize,0)

  this.createButton("previewButton","togglePreview:","configView")
  this.previewButton.layer.opacity = 1.0
  this.previewButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.previewButton.setTitleForState("Preview on hover: "+(this.config.preview?"✅":"🚫"),0)

  this.createButton("singleClickButton","changeClickAction:","configView")
  this.singleClickButton.layer.opacity = 1.0
  this.singleClickButton.click = 1
  this.singleClickButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.singleClickButton.setTitleForState("Single Click on node: "+this.getActionText(self.config.singleClick),0)

  this.createButton("doubleClickButton","changeClickAction:","configView")
  this.doubleClickButton.layer.opacity = 1.0
  this.doubleClickButton.click = 2
  this.doubleClickButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.doubleClickButton.setTitleForState("Double Click on node: "+this.getActionText(self.config.doubleClick),0)

  this.createButton("focusScaleButton","changeFocusScale:","configView")
  this.focusScaleButton.layer.opacity = 1.0
  this.focusScaleButton.click = 2
  this.focusScaleButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.focusScaleButton.setTitleForState("Focus Scale : "+this.config.focusScale,0)

  let color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
  for (let index = 0; index < 16; index++) {
    this["ColorButton"+index] = UIButton.buttonWithType(0);
    this["ColorButton"+index].index = index
    this["ColorButton"+index].hidden = false
    this.setColorButtonLayout(this["ColorButton"+index],"setColorFilter:",color[index],"configView")
    // self["ColorButton"+index].setTitleForState(self.imagePattern[index]===self.textPattern[index]?` ${self.imagePattern[index]} `:"-1",0) 
  }
}
/** @this networkController */
networkController.prototype.settingViewLayout = function (){
    let viewFrame = this.view.bounds
    let width = viewFrame.width
    let height = viewFrame.height
    this.configView.frame = genFrame(width-335,20,335,height-55)

    this.updateButton.frame = genFrame(5,45,325,35) 

    this.linkButton.frame = genFrame(5,170,325,35)
    this.imageSizeButton.frame = genFrame(5,210,325,35)
    this.previewButton.frame = genFrame(5,250,325,35)
    this.singleClickButton.frame = genFrame(5,290,325,35)
    this.doubleClickButton.frame = genFrame(5,330,325,35)
    this.focusScaleButton.frame = genFrame(5,370,325,35)

    let initX = 6
    let initY = 86

    for (let index = 0; index < 16; index++) {
      if (index == 8) {
        initX = 6
        initY = 127
      }
      this["ColorButton"+index].frame = genFrame(initX,initY,37,37)
      this["ColorButton"+index].setTitleForState(this.config.colorFilter[index]?"✓":"✖️",0)
      initX = initX+41
    }
    this.closeConfigButton.frame = genFrame(290, 0, 40, 40)
}
/** @this networkController */
networkController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}
/** @this networkController */
networkController.prototype.creatView = function (viewName,superview="view",color="#9bb2d6",alpha=0.8) {
  this[viewName] = UIView.new()
  this[viewName].backgroundColor = hexColorAlpha(color,alpha)
  this[viewName].layer.cornerRadius = 12
  this[superview].addSubview(this[viewName])
}
/** @this networkController */
networkController.prototype.setColorButtonLayout = function (button,targetAction,color,superview) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.blackColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString(color).colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    button.layer.borderWidth = 2
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this[superview].addSubview(button);
}
/** @this {networkController} */
networkController.prototype.runJavaScript = async function(script,delay) {
  if(!this.webview || !this.webview.window)return;
  return new Promise((resolve, reject) => {
    if (delay) {
      this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(delay, true, () => {
        this.webview.evaluateJavaScript(script,(result) => {resolve(result)});
      })
    }else{
      this.webview.evaluateJavaScript(script,(result) => {resolve(result)});
    }
  })
};

/** @this {networkController} */
networkController.prototype.getImageByHash = function(hash) {
  if (!hash) {
    return `<div class="comment">------------
        Hand writing
        ------------</div>`
  }
  let image = Database.sharedInstance().getMediaByHash(hash)
  if (image) {
    return `<img width="100%" src="data:image/jpeg;base64,${image.base64Encoding()}"/>`
  }else{
    return `<div class="comment">------------
        Hand writing
        ------------</div>`
  }
  
}
/** @this {networkController} */
networkController.prototype.showAllButton = function (frame) {
  this.maxButton.hidden = false
  this.miniMode.hidden = false
  this.moveButton.hidden = false
  this.closeButton.hidden = false
  this.screenButton.hidden = false
  this.searchButton.hidden = false
  this.focusButton.hidden = false
  this.snipasteButton.hidden = false
}
/** @this {networkController} */
networkController.prototype.hideAllButton = function (frame) {
  this.maxButton.hidden = true
  this.miniMode.hidden = true
  this.moveButton.hidden = true
  this.closeButton.hidden = true
  this.screenButton.hidden = true
  this.searchButton.hidden = true
  this.focusButton.hidden = true
  this.snipasteButton.hidden = true
}
/** @this {networkController} */
networkController.prototype.show = function (frame) {
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity

  studyController().view.bringSubviewToFront(this.view)
  this.view.layer.opacity = 0.2
  if (frame) {
    this.view.frame = frame
    this.currentFrame = frame
  }
  this.view.hidden = false
  this.miniMode = false
  // this.webview.hidden = false
  this.hideAllButton()
  UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    this.currentFrame = preFrame
  },
  ()=>{
    this.webview.hidden = false
    this.showAllButton()
  })
}
/** @this {networkController} */
networkController.prototype.hide = function (frame) {
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  // let preFrame = this.view.frame
  // this.webview.hidden = false
  if (this.settingView) {
    this.settingView.hidden = true
  }
  this.hideAllButton()
  this.custom = false
  UIView.animateWithDurationAnimationsCompletion(0.25,()=>{
    this.view.layer.opacity = 0.2
    if (frame) {
      this.view.frame = frame
      this.currentFrame = frame
    }
    // this.view.frame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
    // this.currentFrame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame
    this.custom = preCustom
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  })
}
/** @this {networkController} */
networkController.prototype.getActionText = function (action) {
  switch (action) {
    case 0:
      return "Nothing"
    case 1:
      return 'Show card'
    case 2:
      return 'Snipaste'
    case 3:
      return 'Focus'
    case 4:
      return 'Copy URL'
    default:
      break;
  }
}
/** @this {networkController} */
networkController.prototype.getActionJS = function (action) {
  switch (action) {
    case 0:
      return ""
    case 1:
      return 'window.location.assign("marginnote3app://note/"+properties.nodes[0]);'
    case 2:
      return 'window.location.assign("snipaste://note/"+properties.nodes[0]);'
    case 3:
      return `network.focus(properties.nodes[0],{scale:${this.config.focusScale},animation:true})`
    case 4:
      return 'copyText("marginnote3app://note/"+properties.nodes[0])'
    default:
      break;
  }
}
/** @type {UIView} */
networkController.prototype.view